

#define BMP_W	32
#define BMP_H	32


unsigned char colorTable[4 * 16] = {
	0xff, 0xff, 0xff, 255,
	0xff, 0xff, 0xcc, 255,
	0xff, 0xff, 0x99, 255,
	0xff, 0xff, 0x66, 255,
	0xff, 0xff, 0x33, 255,
	0xff, 0xff, 0x00, 255,
	0xcc, 0xcc, 0x00, 255,
	0x99, 0x99, 0x00, 255,
	0x66, 0x66, 0x00, 255,
	0x33, 0x33, 0x00, 255,
	0x33, 0x66, 0x00, 255,
	0x66, 0xcc, 0x00, 255,
	0x99, 0xff, 0x33, 255,
	0xcc, 0xff, 0x99, 255,
	0xff, 0xff, 0xff, 255,
	0xff, 0xff, 0xff, 255
};

char *CreateBMP16(char *col)
{
	static char buf[54 + 4 * 16 + BMP_W * BMP_H];
	int i, j, max;

	memset(buf, 0x00, sizeof(buf));

	max = 54 + 4 * 16;

	buf[0] = 'B';
	buf[1] = 'M';
	buf[2] = sizeof(buf) & 0xff;
	buf[3] = sizeof(buf) & 0xff00;
	buf[4] = sizeof(buf) & 0xff0000;
	buf[5] = sizeof(buf) & 0xff000000;
	
	buf[10] = max & 0xff;
	buf[11] = max & 0xff00;
	buf[12] = max & 0xff0000;
	buf[13] = max & 0xff000000;
	buf[14] = 0x28;
	
	buf[18] = BMP_W & 0xff;
	buf[19] = BMP_W & 0xff00;
	buf[20] = BMP_W & 0xff0000;
	buf[21] = BMP_W & 0xff000000;
	buf[22] = BMP_H & 0xff;
	buf[23] = BMP_H & 0xff00;
	buf[24] = BMP_H & 0xff0000;
	buf[25] = BMP_H & 0xff000000;
	buf[26] = 0x01;
	buf[27] = 0x00;
	buf[28] = 0x08;
	buf[29] = 0x00;

	buf[42] = buf[38] = 0xc4;
	buf[43] = buf[39] = 0x0e;
	
	buf[50] = buf[46] = 16 & 0xff;
	buf[51] = buf[47] = 16 & 0xff00;
	buf[52] = buf[48] = 16 & 0xff0000;
	buf[53] = buf[49] = 16 & 0xff000000;

	max = 4 * 16;
	for (i = 0; i < max; i++) {
		j = 54 + i;
		buf[j] = colorTable[i];
	}

	max = BMP_W * BMP_H;
	for (i = 0; i < max; i++) {
		j = 54 + 4 * 16 + i;
		buf[j] = col[i];
	}

	return buf;
}

int testbmp(void)
{
	int i, j, hFile;
	char col[BMP_W * BMP_H], *p;

	p = col;
	for (i = 0, j = 0; i != BMP_H; i++) {
		memset(p, j, BMP_W);
		p += BMP_W;
		if (i % 2 == 0) {
			j++;
		}
	}
	p = CreateBMP16(col);

	hFile = api_fopenEx("test.bmp", 0);
	api_fwrite(p, 54 + 4 * 16 + BMP_W * BMP_H, hFile);
	api_fcloseEx(hFile);

	return 1;
}
