#ifndef APILIB
#define APILIB

struct MOUSE_INFO {
	int x, y, button, state;
};
struct SYS_INFO {
	unsigned char cyls;			/* u[gZN^͂ǂ܂ŃfBXNǂ񂾂̂ */
	unsigned char leds;			/* u[g̃L[{[hLED̏ */
	unsigned char vmode;		/* rfI[h  rbgJ[ */
	unsigned char reserve;		/* \ */
	unsigned short scrnx;		/* ʉ𑜓x */
	unsigned short scrny;		/* ʉ𑜓x */
	unsigned char *vram;		/* VRAM̃AhX */
	unsigned short os_type;		/* OS̎ */
};
struct TIME_INFO {
	int year, month, day, hour, minutes, second;
};
struct POINT {
	short x, y;
};

#define COL8_000000		0
#define COL8_FF0000		1
#define COL8_00FF00		2
#define COL8_FFFF00		3
#define COL8_0000FF		4
#define COL8_FF00FF		5
#define COL8_00FFFF		6
#define COL8_FFFFFF		7
#define COL8_C6C6C6		8
#define COL8_840000		9
#define COL8_008400		10
#define COL8_848400		11
#define COL8_000084		12
#define COL8_840084		13
#define COL8_008484		14
#define COL8_848484		15

#define KEY_UP			0x9e8
#define KEY_DOWN		0x9f0
#define KEY_LEFT		0x9eb
#define KEY_RIGHT		0x9ed

#define LANG_US			0
#define LANG_SJIS		1
#define LANG_EUC		2

void api_putchar(int c);
void api_putstr0(char *s);
void api_putstr1(char *s, int l);
void api_end(void);
int api_openwin(short *buf, int xsiz, int ysiz, int col_inv, char *title);
void api_putstrwin(int win, int x, int y, int col, int len, char *str);
void api_boxfilwin(int win, int x0, int y0, int x1, int y1, int col);
void api_initmalloc(void);
char *api_malloc(int size);
void api_free(char *addr, int size);
void api_point(int win, int x, int y, int col);
void api_refreshwin(int win, int x0, int y0, int x1, int y1);
void api_linewin(int win, int x0, int y0, int x1, int y1, int col);
void api_closewin(int win);
int api_getkey(int mode);
int api_alloctimer(void);
void api_inittimer(int timer, int data);
void api_settimer(int timer, int time);
void api_freetimer(int timer);
void api_beep(int tone);
int api_fopen(char *fname);
void api_fclose(int fhandle);
void api_fseek(int fhandle, int offset, int mode);
int api_fsize(int fhandle, int mode);
int api_fread(char *buf, int maxsize, int fhandle);
int api_cmdline(char *buf, int maxsize);
int api_getlang(void);
void api_osselect(int i);
int api_sendkey(char *str);
int api_srand(int i);
int api_rand(void);
int api_fopenEx(char *fname, int mode);
void api_fcloseEx(int fhandle);
int api_fwrite(char *buf, int maxsize, int fhandle);
int api_isact(void);
int api_loadimg(int win, int x, int y, char *fname);
struct POINT api_getimgsize(char *fname);
void api_conscolor(int col);
void api_consbksp(void);
void tomo_getmouse(int win, struct MOUSE_INFO *info);
int tomo_gettick(void);
void tomo_sysinfo(struct SYS_INFO *info);
void tomo_systime(struct TIME_INFO *info);
void tomo_cpuid(int id_eax, int id_ecx, int *eax, int *ebx, int *ecx, int *edx);
#endif
