
#ifndef __STDM__
#define __STDM__

#define EOF -1

typedef struct {
	int h;
	int mode;
	int seek;
} FILE;

FILE *fopen(char *filename, char *mode);
int fclose(FILE *fp);
int fputs(char *str, FILE *fp);
int fread(void *buf, int size, int n, FILE *fp);
int fwrite(void *buf, int size, int n, FILE *fp);
int putchar(int c);

FILE *fopen(char *filename, char *mode)
{
	static FILE file;
	file.h = 0;
	file.mode = -1;
	file.seek = 0;

	if (!strcmp(mode, "r")) {
		file.mode = 0;
		file.h = (int)api_fopen(filename);
	}
	if (!strcmp(mode, "w")) {
		file.mode = 1;
		file.h = (int)api_fopenEx(filename, 0);
		api_fwrite("", 0, file.h);
	}
	if (!strcmp(mode, "a")) {
		file.mode = 2;
		file.h = (int)api_fopenEx(filename, 1);
	}
	if (file.h == 0) {
		return NULL;
	} else {
		return &file;
	}
}

int fclose(FILE *fp)
{
	if (fp->mode == 0) {
		api_fclose(fp->h);
	} else {
		api_fcloseEx(fp->h);
	}
	return 0;
}

int fputs(char *str, FILE *fp)
{
	if (api_fsize(fp->h, 0) == 0) {
		api_fwrite(str, strlen(str), fp->h);
		return 0;
	}
	char *s = (char *)api_malloc(api_fsize(fp->h, 0)+strlen(str));
	api_fread(s, api_fsize(fp->h, 0), fp->h);
	sprintf(s, "%s%s", s, str);
	api_fwrite(s, strlen(s), fp->h);
	api_free(s, strlen(s));
	return 0;
}

int fread(void *buf, int size, int n, FILE *fp)
{
	api_fread(buf, size * n, fp->h);
	return n;
}

int fwrite(void *buf, int size, int n, FILE *fp)
{
	api_fwrite(buf, size * n, fp->h);
	return n;
}

int putchar(int c)
{
	api_putchar(c);
	return c;
}

void *malloc(unsigned int size)
{
	char *p = api_malloc(size + 16);
	if (p != 0) {
		*((int *) p) = size;
		p += 16;
	}
	return p;
}

void free(void *p)
{
	char *q = p;
	int size;
	if (q != 0) {
		q -= 16;
		size = *((int *) q);
		api_free(q, size + 16);
	}
	return;
}

#endif
