#include "../apilib.h"

#include <stdio.h>
#include <string.h>

int strtol(char *s, char **endp, int base);

char *skipspace(char *p);
void textview(int win, int w, int h, int xskip, char *p, int tab, int lang);
char *lineview(int win, int w, int y, int xskip, unsigned char *p, int tab, int lang);
void putrtf(int win, int x, int y, char *s);
int puttab(int x, int w, int xskip, char *s, int tab);
void strrep(char *buf, char *pre, char *aft);
void hexdec(char *a);

/* RTFr[ */

int bold = 0;
int italic = 0;
int underline = 0;
int strike = 0;
int sup = 0;
int sub = 0;
char ret;

int main(void)
{
	short winbuf[1024 * 757];
	char txtbuf[240 * 1024];
	int w = 40, h = 20, t = 4, spd_x = 1, spd_y = 1;
	int win, i, j, lang = api_getlang(), xskip = 0;
	char s[30], *p, *q = 0, *r = 0, *u = 0;

	/* R}hC */
	api_cmdline(s, 30);
	for (p = s; *p > ' '; p++);		/* Xy[X܂œǂݔ΂ */
	while (*p != 0) {
		p = skipspace(p);
		if (*p == '-') {
			if (p[1] == 'w') {
				w = strtol(p + 2, &p, 0);
				if (w < 20) {
					w = 20;
				}
				if (w > 126) {
					w = 126;
				}
			} else if (p[1] == 'h') {
				h = strtol(p + 2, &p, 0);
				if (h < 1) {
					h = 1;
				}
				if (h > 45) {
					h = 45;
				}
			} else if (p[1] == 't') {
				t = strtol(p + 2, &p, 0);
				if (t < 1) {
					t = 4;
				}
			} else {
err:
				api_putstr0(" >rtfview file [-w40 -h20 -t4]\n");
				api_end();
			}
		} else {	/* t@C */
			if (q != 0) {
				goto err;
			}
			q = p;
			while (*p > ' ') p++;		/* Xy[X܂œǂݔ΂ */
			r = p;
		}
	}
	if (q == 0) {
		goto err;
	}

	/* EBhȄ */
	win = api_openwin(winbuf, w * 8 + 16, h * 16 + 37, -1, "rtfview");
	api_boxfilwin(win, 6, 27, w * 8 + 9, h * 16 + 30, 7);

	/* t@Cǂݍ */
	*r = 0;
	i = api_fopen(q);
	if (i == 0) {
		api_putstr0("File open error.\n");
		api_end();
	}
	j = api_fsize(i, 0);
	if (j >= 240 * 1024 - 1) {
		j = 240 * 1024 - 2;
	}
	txtbuf[0] = 0x0a; /* ԕp̉sR[h */
	api_fread(txtbuf + 1, j, i);
	api_fclose(i);
	txtbuf[j + 1] = 0;
	q = txtbuf + 1;
	for (p = txtbuf + 1; *p != 0; p++) {	/* ȒPɂ邽߂0x0d̃R[h */
		if (*p != 0x0d) {
			*q = *p;
			q++;
		}
	}
	*q = 0;

	/* C */
	p = txtbuf + 1;

	if ( strncmp(p, "{\\rtf1", 6) != 0 ) {
		api_end();
	}

	p += 6;

	if ( strncmp(p, "\\ansi", 5) == 0 ) {				/* ANSI(ftHg) */
		p += 5;
	} else if ( strncmp(p, "\\mac", 4) == 0 ) {			/* Apple Macintosh */
		p += 4;
	} else if ( strncmp(p, "\\pc", 3) == 0 ) {			/* IBM PC code page 437 */
		p += 3;
	}

	do p++; while ( strncmp(p, "fs22", 4) != 0 );		/* {ʒu܂œǂݔ΂ */
	p += 5;
	p[-1] = 0x0a;
	u = p;

	/* \parsɂ */
	strrep(p, "\\par\n", "\n");
	strrep(p, "}", "");
	
	char *x = p;

	while (*x != 0) {
		if (strncmp(x, "\\\'", 2) == 0) {
			volatile char ss[4];
			strncpy((char *)ss, x, 4);
			ss[4] = 0x00;
			hexdec(x);
			strrep(x, (char *)ss, &ret);
		}
		x++;
	}

	strrep(p, "\\b0", "''"); strrep(p, "\\b", "''");
	strrep(p, "\\i0", "'''"); strrep(p, "\\i", "'''");
	strrep(p, "\\strike0", "%%"); strrep(p, "\\strike", "%%");
	strrep(p, "\\ulnone", "%%%"); strrep(p, "\\ul", "%%%");
	strrep(p, "\\tab", "\t");

	/* \ďI */
	while (1) {
		textview(win, w, h, xskip, p, t, lang);
		i = api_getkey(1);
		if (i == 'Q' || i == 'q') {
			api_end();
		}
		if ('A' <= i && i <= 'F') {
			spd_x = 1 << (i - 'A');	/* 1, 2, 4, 8, 16, 32 */
		}
		if ('a' <= i && i <= 'f') {
			spd_y = 1 << (i - 'a');	/* 1, 2, 4, 8, 16, 32 */
		}
		if (i == '<' && t > 1) {
			t /= 2;
		}
		if (i == '>' && t < 256) {
			t *= 2;
		}
		if (i == 0x9eb) {
			xskip -= spd_x;
			if (xskip < 0)
				xskip = 0;
		}
		if (i == 0x9ed) {
			xskip += spd_x;
		}
		if (i == 0x9e8) {
				for (j = 0; j < spd_y; j++) {
					if (p == u)
						break;
					for (p--; p[-1] != 0x0a; p--) { } /* ꕶO0x0ał܂ł̂ڂ */
				}
		}
		if (i == 0x9f0) {
			for (j = 0; j < spd_y; j++) {
				for (q = p; *q != 0 && *q != 0x0a; q++) { }
				if (*q == 0)
					break;
				p = q + 1;
			}
		}
	}
}

char *skipspace(char *p)
{
	while (*p == ' ') p++;	/* Xy[Xǂݔ΂ */
	return p;
}

void textview(int win, int w, int h, int xskip, char *p, int tab, int lang)
{
	int i;
	api_boxfilwin(win + 1, 8, 29, w * 8 + 7, h * 16 + 28, 7);
	for (i = 0; i < h; i++) {
		p = lineview(win, w, i * 16 + 29, xskip, p, tab, lang);
	}
	api_refreshwin(win, 8, 29, w * 8 + 8, h * 16 + 29);
	return;
}

char *lineview(int win, int w, int y, int xskip, unsigned char *p, int tab, int lang)
{
	int x = -xskip;
	char s[130];
	while (1) {
		if (*p == 0)
			break;
		if (*p == 0x0a) {
			p++;
			break;
		}
		/* ߂ǂShiftJIŜ݂̑ΉB^^; */
		if (*p == 0x09) {
			x = puttab(x, w, xskip, s, tab);
			p++;
		} else if ((0x81 <= *p && *p <= 0x9f) || (0xe0 <= *p && *p <= 0xfc)) {
			/* Sp */
			if (x == -1)
				s[0] = ' ';
			if (0 <= x && x < w - 1) {
				s[x]     = *p;
				s[x + 1] = p[1];
			}
			if (x == w - 1)
				s[x] = ' ';
			x += 2;
			p += 2;
		} else {
			if (0 <= x && x < w)
				s[x] = *p;
			x++;
			p++;
		}
	}
	if (x > w)
		x = w;
	if (x > 0) {
		s[x] = 0;
		putrtf(win, x, y, s);
	}
	return p;
}

void putrtf(int win, int x, int y, char *s)
{
	int i;

	api_putstrwin(win + 1, 8, y, 0, 1, s);
	return;
}

int puttab(int x, int w, int xskip, char *s, int tab)
{
	while (1) {
		if (0 <= x && x < w)
			s[x] = ' ';
		x++;
		if ((x + xskip) % tab == 0)
			break;
	}
	return x;
}

void strrep(char *buf, char *pre, char *aft)
{
	char *p;
	p = strstr(buf, pre);
	if (p) {
		char *p2 = p + strlen(pre);
		strrep(p2, pre, aft);
		memmove(p + strlen(aft), p2, strlen(p2)+1);
		memcpy(p, aft, strlen(aft));
	}
	return;
}

void hexdec(char *a)
{
	int n = 0;
	char s[4];
	strncpy(s, a, 4);
	if (strncmp(s, "\\\'", 2) == 0) {
		ret = (char)strtol(&s[n+2], NULL, 16);
	}
	return;
}
