#include "bootpack.h"
#include "ide.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define	VAR_WALL		0x00
#define	VAR_OSNAME		0x01
#define PROMPT			0x02

extern struct SHEET *ActiveSheet;
extern char cpath[256];
extern char epath[1024];
void dir_cons(struct CONSOLE *cons, struct FILEINFO *finfo);
char cmd_history[256];

extern unsigned short table_8_565[256];

void cons_runcmd(char *cmdline, struct CONSOLE *cons, int *fat, int memtotal)
{
	strcpy(cmd_history, cmdline);
	if (!strncmp(cmdline, "@", 1)) {
		cmdline++;
	}
	if (strcmp(cmdline, "mem") == 0) {
		cmd_mem(cons, memtotal);

	} else if (strcmp(cmdline, "cls") == 0) {
		cmd_cls(cons);

	} else if (strcmp(cmdline, "clear") == 0) {
		cmd_cls(cons);

	} else if (strcmp(cmdline, "clean") == 0) {
		cmd_cls(cons);

	} else if (strcmp(cmdline, "dir") == 0) {
		cmd_dir(cons, fat);

	} else if (strcmp(cmdline, "dircd") == 0) {
		cmd_dir_cd(cons);

	} else if (strcmp(cmdline, "ls") == 0) {
		cmd_dir(cons, fat);

	} else if (strcmp(cmdline, "exit") == 0) {
		cmd_exit(cons, fat);

	} else if (strcmp(cmdline, "quit") == 0) {
		cmd_exit(cons, fat);

	} else if (strcmp(cmdline, "q") == 0) {
		cmd_exit(cons, fat);

	} else if (strncmp(cmdline, "rem", 3) == 0) {
		/* ɂȂ */

	} else if (strncmp(cmdline, "nop", 3) == 0) {
		/* ɂȂ */

	} else if (strcmp(cmdline, OS_NAMEL) == 0) {
		cmd_isotope(cons);

	} else if (strcmp(cmdline, "reset") == 0) {
		cmd_reset(cons);

	} else if (strcmp(cmdline, "ver") == 0) {
		cmd_isotope(cons);

	} else if (strcmp(cmdline, "time") == 0) {
		cmd_time(cons);

	} else if (strcmp(cmdline, "shutdown") == 0) {
		cmd_shutdown(cons);

	} else if (strncmp(cmdline, "cd2copy ", 8) == 0) {
		cmd_cd_start(cons, cmdline, fat);

	} else if (strcmp(cmdline, "mes") == 0) {
		msgbox("message test");

	} else if (strncmp(cmdline, "start ", 6) == 0) {
		cmd_start(cons, cmdline, memtotal);

	} else if (strncmp(cmdline, "ncst ", 5) == 0) {
		cmd_ncst(cons, cmdline, memtotal);
		
	} else if (strncmp(cmdline, "del ", 4) == 0) {
		cmd_del(cons, cmdline, fat);

	} else if (strncmp(cmdline, "langmode ", 9) == 0) {
		cmd_langmode(cons, cmdline);
		
	} else if (strncmp(cmdline, "wall ", 5) == 0) {
		cmd_setvar(cons, cmdline, VAR_WALL, fat);

	} else if (strncmp(cmdline, "prompt ", 7) == 0) {
		cmd_setvar(cons, cmdline, PROMPT, fat);

	} else if (strncmp(cmdline, "sound ", 6) == 0) {
		cmd_sound(cons, cmdline);

	} else if (strcmp(cmdline, "mgxv") == 0) {
		os_ver();

	} else if (strncmp(cmdline, "exist ", 6) == 0) {
		struct FILEINFO *finfo;
		finfo = file_search(cmdline + 6, (struct FILEINFO *) (ADR_DISKIMG + 0x002600), 224);

		cons_putstr0(cons, cmdline + 6);
		cons_putstr0(cons, " is ");
		if (finfo == 0) {
			cons_putstr0(cons, "not ");
		}
		cons_putstr0(cons, "found.\n");
		
	} else if (strncmp(cmdline, "create ", 7) == 0) {
		struct FILEINFO *finfo;
		struct FILEHANDLE *fh;

		char *nulbuf = "";

		finfo = file_search(cmdline + 7, (struct FILEINFO *) (ADR_DISKIMG + 0x002600), 224);
		if (finfo != 0) {
			cons_putstr0(cons, cmdline + 7);
			cons_putstr0(cons, " is already exist.\n");
			return;
		}
		hrb_api_fopen(cmdline + 7, 0, fh, fat);
		hrb_api_fwrite(nulbuf, 0, fh, fat);
		hrb_api_fclose(fh, fat);
		cons_putstr0(cons, "Created!\n");

	} else if (cmdline[0] != 0) {
		if (cmd_app(cons, fat, cmdline) == 0) {
			cmd_notfound(cmdline, cons);
		}
	}
	return;
}

void cmd_mem(struct CONSOLE *cons, int memtotal)
{
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	char s[60];
	sprintf(s, "total   %dMB\nfree %dKB\n\n", memtotal / (1024 * 1024), memman_total(memman) / 1024);
	cons_putstr0(cons, s);
	return;
}

void cmd_cls(struct CONSOLE *cons)
{
	extern int cons_xsize;
	extern int cons_ysize;

	int x, y;
	struct SHEET *sheet = cons->sht;
	for (y = 28; y < 28 + cons_ysize*16; y++) {
		for (x = 8; x < 8 + cons_xsize*8; x++) {
			sheet->buf[x + y * sheet->bxsize] = table_8_565[cons->back_c];
		}
	}
	sheet_refresh(sheet, 8, 28, 8 + cons_xsize*8, 28 + cons_ysize*16);
	cons->cur_y = 28;
	return;
}

void cmd_dir(struct CONSOLE *cons, int *fat)
{
	struct FILEINFO *finfo = (struct FILEINFO *) (ADR_DISKIMG + 0x002600);
	int i, j;
	char s[30];
	for (i = 0; i < 224; i++) {
		if (finfo[i].name[0] == 0x00)
			break;
		if (finfo[i].name[0] != 0xe5) {
			if ((finfo[i].type & 0x18) == 0) {
				sprintf(s, "filename.ext   %7d\n", finfo[i].size);
				for (j = 0; j < 8; j++) s[j] = finfo[i].name[j];
				s[ 9] = finfo[i].ext[0];
				s[10] = finfo[i].ext[1];
				s[11] = finfo[i].ext[2];
				cons_putstr0(cons, s);
			}
		}
	}
	cons_newline(cons);
	return;
}

void cmd_del(struct CONSOLE *cons, char *cmdline, int *fat)
{
	if (hrb_api_remove(cmdline + 4, fat) == -1)
		cons_putstr0(cons, "Couldn't find file.\n\n");
	return;
}

void cmd_exit(struct CONSOLE *cons, int *fat)
{
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	struct TASK *task = task_now();
	struct SHTCTL *shtctl = (struct SHTCTL *) *((int *) 0x0fe4);
	struct FIFO32 *fifo = (struct FIFO32 *) *((int *) 0x0fec);
	if (cons->sht != 0) {
		timer_cancel(cons->timer);
	}
	memman_free_4k(memman, (int) fat, 4 * 2880);
	io_cli();
	if (cons->sht != 0) {
		fifo32_put(fifo, cons->sht - shtctl->sheets0 + 768);	/* 768`1023 */
	} else {
		fifo32_put(fifo, task - taskctl->tasks0 + 1024);	/* 1024`2023 */
	}
	io_sti();
	while (1) {
		task_sleep(task);
	}
}

void cmd_start(struct CONSOLE *cons, char *cmdline, int memtotal)
{
	struct SHTCTL *shtctl = (struct SHTCTL *) *((int *) 0x0fe4);
	struct SHEET *sht = open_console(shtctl, memtotal);
	struct FIFO32 *fifo = &sht->task->fifo;
	int i;
	sheet_slide(sht, 32, 4);
	sheet_updown(sht, shtctl->top);
	/* R}hCɓ͂ꂽAꕶVR\[ɓ */
	for (i = 6; cmdline[i] != 0; i++) {
		fifo32_put(fifo, cmdline[i] + 256);
	}
	fifo32_put(fifo, 10 + 256);	/* Enter */
	cons_newline(cons);
	return;
}

void cmd_dir_cd(struct CONSOLE *cons)
{
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	char s[60];
	int controller, deviceNo;
	PrimaryVolumeDescriptor* pvd;
	DirectoryEntry* root;
	dword size;
	dword position;
	byte* buffer;

	/*  */
	IDEDriver *driver = (IDEDriver *) memman_alloc_4k(memman, sizeof(IDEDriver));
	IDEDriver_IDEDriver(driver, IDE_IRQ_PRIMARY, IDE_IRQ_SECONDARY);

	/* ATAPI foCX̌ */
	if (!IDEDriver_findDevice(driver, DEVICE_ATAPI, 0x05, &controller, &deviceNo))
		return;

	/* ATAPI foCX̎gpJn */
	if (!IDEDriver_selectDevice(driver, controller, deviceNo))
		return;

	/* {{[Lqq̓ǂݍ */
	pvd = (PrimaryVolumeDescriptor*) memman_alloc_4k(memman, sizeof(PrimaryVolumeDescriptor));
	IDEDriver_read(driver, 16, pvd, SECTOR_SIZE); /* 16ZN^[܂ł̓u[g̈Ȃ̂ */
	if (pvd->type[0] != ISO_PRIMARY_VOLUME_DESCRIPTOR || strncmp("CD001", pvd->id, 5) != 0)
		return;

	/* [gfBNgǂݍ */
	root = (DirectoryEntry *)( pvd->root_directory_record );
	size = ((dword)((root->size_l + SECTOR_SIZE - 1) / SECTOR_SIZE)) * SECTOR_SIZE;
	buffer = (byte *) memman_alloc_4k(memman, size);
	IDEDriver_read(driver, root->extent_l, buffer, size);
	for (position = 0; position < size;) {
		DirectoryEntry* dir = (DirectoryEntry *) (buffer + position);
		if (dir->size_l == 0) {
			break;
		} else if (dir->directory == 0) {
			dir->name[dir->name_len - 2] = '\0';
			sprintf(s, "%8d  %s\n", dir->size_l, dir->name);
			cons_putstr0(cons, s);
		}
		position += dir->length;
	}
	memman_free_4k(memman, (int) buffer, size);
	cons_newline(cons);
	
	return;
}

void cmd_cd_start(struct CONSOLE *cons, char *cmdline, int *fat)
{
    /*  */
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
    IDEDriver* driver = (IDEDriver *) memman_alloc_4k(memman, sizeof(IDEDriver));
    IDEDriver_IDEDriver(driver, IDE_IRQ_PRIMARY, IDE_IRQ_SECONDARY);
	struct FILEHANDLE *fh = 0;

    /* ATAPI foCX̌ */
    int controller, deviceNo;
    if ( !IDEDriver_findDevice(driver, DEVICE_ATAPI, 0x05, &controller, &deviceNo) )
        return;

    /* ATAPI foCX̎gpJn */
    if ( !IDEDriver_selectDevice(driver, controller, deviceNo) )
        return;

    /* {{[Lqq̓ǂݍ */
    PrimaryVolumeDescriptor* pvd = (PrimaryVolumeDescriptor*) memman_alloc_4k(memman, sizeof(PrimaryVolumeDescriptor));
    IDEDriver_read(driver, 16, pvd, SECTOR_SIZE); /* 16ZN^[܂ł̓u[g̈Ȃ̂ */
    if (pvd->type[0] != ISO_PRIMARY_VOLUME_DESCRIPTOR || strncmp("CD001", pvd->id, 5) != 0)
        return;

    /* [gfBNgǂݍ */
    DirectoryEntry* root = (DirectoryEntry *)( pvd->root_directory_record );
    dword size = ((dword)((root->size_l + SECTOR_SIZE - 1) / SECTOR_SIZE)) * SECTOR_SIZE;
    byte* buffer = (byte *) memman_alloc_4k(memman, size);
    IDEDriver_read(driver, root->extent_l, buffer, size);
    dword position;
    for (position = 0; position < size;) {
        DirectoryEntry* dir = (DirectoryEntry *) (buffer + position);
        if (dir->size_l == 0) {
            break;
        } else if (dir->directory == 0) {
            if (strncmp(dir->name, cmdline + 8, 12) == 0) {
                byte* data = (byte *) memman_alloc_4k(memman, size);
                IDEDriver_read(driver, dir->extent_l, data, dir->size_l);
				hrb_api_fopen(cmdline + 8, 0, fh, fat);
				hrb_api_fwrite(data, size, fh, fat);
				hrb_api_fclose(fh, fat);
				file_list(fat);
                return;
            }
        }
        position += dir->length;
    }
    memman_free_4k(memman, (int) buffer, size);
	cons_newline(cons);
	return;
}

void cmd_ncst(struct CONSOLE *cons, char *cmdline, int memtotal)
{
	struct TASK *task = open_constask(0, memtotal);
	struct FIFO32 *fifo = &task->fifo;
	int i;
	/* R}hCɓ͂ꂽAꕶVR\[ɓ */
	for (i = 5; cmdline[i] != 0; i++) {
		fifo32_put(fifo, cmdline[i] + 256);
	}
	fifo32_put(fifo, 10 + 256);	/* Enter */
	cons_newline(cons);
	return;
}

void cmd_langmode(struct CONSOLE *cons, char *cmdline)
{
	struct TASK *task = task_now();
	unsigned char mode = cmdline[9] - '0';
	if (mode <= 2) {
		task->langmode = mode;
	} else {
		cons_putstr0(cons, "Invalid langmode number.\n");
	}
	cons_newline(cons);
	return;
}

void cmd_setvar(struct CONSOLE *cons, char *cmdline, int mode, int *fat)
{
	if (mode == VAR_WALL) {
		OS_WALLJPG = &cmdline[5];
		cons_putstr0(cons, OS_WALLJPG);
	}
	if (mode == VAR_OSNAME) {
	}
	if (mode == PROMPT) {
		strncpy(&cons_prompt, &cmdline[7], 1);
	}

	cons_newline(cons);
	return;
}

extern struct TASK *sound;
void cmd_sound(struct CONSOLE *cons, char *cmdline)
{
	char *p;
	p = &cmdline[6];
	if (M_ADLIB) {
		if (!strncmp(p, "play ", 5)) {
			fifo32_put(&sound->fifo, (int)strtol(&cmdline[11], NULL, 10));
		}
		if (!strcmp(p, "stop")) {
			fifo32_put(&sound->fifo, 0);
		}
	} else {
		cons_putstr0(cons, "Adlib not found.");
	}
	cons_newline(cons);
	return;
}

void cmd_isotope(struct CONSOLE *cons)
{
	cons_putstr0(cons, OS_AUTHOR);
	cons_putstr0(cons, " ");
	cons_putstr0(cons, OS_NAMEU);
	cons_putstr0(cons, "\n\t ");
	cons_putstr0(cons, "[version ");
	cons_putstr0(cons, OS_VER);
	cons_putstr0(cons, "]\n\n");
	return;
}

void cmd_time(struct CONSOLE *cons)
{
	unsigned char s[24], t[7];
	readrtc(t);
	sprintf(s, "%02X%02X/%02X/%02X %02X:%02X:%02X\n\n", t[6], t[5], t[4], t[3], t[2], t[1], t[0]);
	cons_putstr0(cons, s);
	return;
}

void cmd_reset(struct CONSOLE *cons)
{
	sys_reset();
}

void cmd_shutdown(struct CONSOLE *cons)
{
	sys_shutdown();
}

void cmd_help(struct CONSOLE *cons, int *fat, int memtotal, int mode)
{
	if (mode == 0) {
		cons_runcmd("langmode 1", cons, fat, memtotal);
		cons_runcmd("ncst tview help.txt", cons, fat, memtotal);
	} else if (mode == 1) {
		cons_runcmd("langmode 1", cons, fat, memtotal);
		cons_runcmd("ncst tview cmd.txt", cons, fat, memtotal);
	}
}

int cmd_app(struct CONSOLE *cons, int *fat, char *cmdline)
{
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	struct FILEINFO *finfo;
	char name[18], *p, *q;
	struct TASK *task = task_now();
	int i, segsiz, datsiz, esp, dathrb, appsiz;
	struct SHTCTL *shtctl;
	struct SHEET *sht;

	/*
	              
	               MOGEX ̎st@C 
	              
	
	 gq              l              VOl` 
	
	  .V      OVISCO̖cB     MOGE    
	  .HRB    c͂ڂOSst@C      Hari    
	

	*/

	/* R}hCt@C𐶐 */
	for (i = 0; i < 13; i++) {
		if (cmdline[i] <= ' ') {
			break;
		}
		name[i] = cmdline[i];
	}
	name[i] = 0; /* Ƃ肠t@Č0ɂ */

	/* t@CT */
	finfo = file_search(name, (struct FILEINFO *) (ADR_DISKIMG + 0x002600), 224);
	if (finfo == 0) {
		/* Ȃ̂Ō".V"ĂxTĂ݂ */
		name[i    ] = '.';
		name[i + 1] = 'V';
		name[i + 2] = 0;
		finfo = file_search(name, (struct FILEINFO *) (ADR_DISKIMG + 0x002600), 224);
	}
	if (finfo == 0) {
		/* Ȃ̂Ō".HRB"ĂxTĂ݂ */
		name[i    ] = '.';
		name[i + 1] = 'H';
		name[i + 2] = 'R';
		name[i + 3] = 'B';
		name[i + 4] = 0;
		finfo = file_search(name, (struct FILEINFO *) (ADR_DISKIMG + 0x002600), 224);
	}
	if (finfo == 0) {
		/* Ȃ̂Ō".HSF"ĂxTĂ݂ */
		name[i    ] = '.';
		name[i + 1] = 'H';
		name[i + 2] = 'S';
		name[i + 3] = 'F';
		name[i + 4] = 0;
		finfo = file_search(name, (struct FILEINFO *) (ADR_DISKIMG + 0x002600), 224);
	}


	if (finfo != 0) {
		/* t@Cꍇ */
		appsiz = finfo->size;
		p = file_loadfile2(finfo->clustno, &appsiz, fat);
		if (appsiz >= 36 && (strncmp(p + 4, "Hari", 4) == 0 || strncmp(p + 4, "MOGE", 4) == 0) && *p == 0x00) {
			segsiz = *((int *) (p + 0x0000));
			esp    = *((int *) (p + 0x000c));
			datsiz = *((int *) (p + 0x0010));
			dathrb = *((int *) (p + 0x0014));
			q = (char *) memman_alloc_4k(memman, segsiz);
			task->ds_base = (int) q;
			set_segmdesc(task->ldt + 0, appsiz - 1, (int) p, AR_CODE32_ER + 0x60);
			set_segmdesc(task->ldt + 1, segsiz - 1, (int) q, AR_DATA32_RW + 0x60);
			for (i = 0; i < datsiz; i++) {
				q[esp + i] = p[dathrb + i];
			}
			start_app(0x1b, 0 * 8 + 4, esp, 1 * 8 + 4, &(task->tss.esp0));
			shtctl = (struct SHTCTL *) *((int *) 0x0fe4);
			for (i = 0; i < MAX_SHEETS; i++) {
				sht = &(shtctl->sheets0[i]);
				if ((sht->flags & 0x11) == 0x11 && sht->task == task) {
					/* AvJςȂɂ𔭌 */
					sheet_free(sht);	/*  */
				}
			}
			for (i = 0; i < 8; i++) {	/* N[YĂȂt@CN[Y */
				if (task->fhandle[i].buf != 0) {
					memman_free_4k(memman, (int) task->fhandle[i].buf, task->fhandle[i].size);
					task->fhandle[i].buf = 0;
				}
			}
			beep(0);
			timer_cancelall(&task->fifo);
			memman_free_4k(memman, (int) q, segsiz);
			task->langbyte1 = 0;
		} else if (strncmp(p, "rem mgxbat", 3 + 1 + 6) == 0) {		// MOGEXob`
			char *ss;
			int x;
			i = finfo->size;
			ss = file_loadfile2(finfo->clustno, &i, fat);
			for (x = 0; x < i; x++) {
				if (ss[x] != 0x0d) {
					fifo32_put(&ActiveSheet->task->fifo, ss[x] + 256);
				}
			}
		} else {
			cons_putstr0(cons, "Invalid header.\n");
		}
		memman_free_4k(memman, (int) p, appsiz);
		cons_newline(cons);
		return 1;
	}
	/* t@CȂꍇ */
	return 0;
}

void cmd_notfound(char *cmdline, struct CONSOLE *cons)
{
	cons_putstr0(cons, "Bad command.\n\n");
	return;
}

void dir_cons(struct CONSOLE *cons, struct FILEINFO *finfo)
{
	int i;
	char s[30];
	memset(s, 0, sizeof(s));
	if (finfo->name[0] != 0xe5) {
		if ((finfo->type & 0x18) == 0) {
			sprintf(s, "filename.ext   %7d\n", finfo->size);
			for (i = 0; i < 8; i++) {
				s[i] = finfo->name[i];
			}
			s[ 9] = finfo->ext[0];
			s[10] = finfo->ext[1];
			s[11] = finfo->ext[2];
		} else if ((finfo->type & 0x10) == 0x10) {
			sprintf(s, "dir0name       <DIR>  \n");
			for (i = 0; i < 8; i++) {
				s[i] = finfo->name[i];
			}
		}
		cons_putstr0(cons, s);
	}
	return;
}
