#include "bootpack.h"
#include <stdio.h>
#include <string.h>
unsigned char rgb2pal(int r, int g, int b, int x, int y);

extern struct SHEET *ActiveSheet;
extern unsigned short table_8_565[256];
extern struct SHTCTL *shtctl;

void black_screen8(void)
{
	char *str = "Shutting down...";
	struct BOOTINFO *binfo = (struct BOOTINFO *) ADR_BOOTINFO;
	boxfill8((short *)binfo->vram, binfo->scrnx, COL8_000000, 0, 0, binfo->scrnx, binfo->scrny);
	putfonts8_asc((short *)binfo->vram, binfo->scrnx, binfo->scrnx/2-strlen(str)*8/2, binfo->scrny/2-16/2, COL8_FFFFFF, str);
	return;
}

void load_screen8(int *fat, unsigned short *vram, int x, int y)
{
	boxfill8(vram, x, COL8_008484, 0, 0, x, y);
	return;
}

void init_screen8(int *fat, unsigned short *vram, int x, int y)
{
	/* ǎ̓ǂݍ */
	if (loadimg(vram, OS_WALLJPG, 0, 0, x, fat) != 0) {
		boxfill8(vram, x, COL8_008484,  0,     0,      x -  1, y - 29);
	}

	/* ^XNo[ */
	boxfill8(vram, x, COL8_FFFFFF,  0, y - 30,  x, y - 30);
	boxfill8(vram, x, COL8_C6C6C6,  0, y - 29,  x, y -  1);

	boxfill8(vram, x, COL8_848484, 69, y - 25,  69, y - 4);
	boxfill8(vram, x, COL8_FFFFFF, 70, y - 25,  70, y - 4);

	return;
}

void init_mouse_cursor8(short *mouse, char bc)
/* }EXJ[\i16x16j */
{
	static char *cursor[16] = {
		"**..............",
		"*O*.............",
		"*OO*............",
		"*OOO*...........",
		"*OOOO*..........",
		"*OOOOO*.........",
		"*OOOOOO*........",
		"*OOOOOOO*.......",
		"*OOOOOOOO*......",
		"*OOOOO*****.....",
		"*OO*OO*.........",
		"*O*.*OO*........",
		"**..*OO*........",
		"*....*OO*.......",
		".....*OO*.......",
		"......**........"
	};
	int x, y;

	for (y = 0; y < 16; y++) {
		for (x = 0; x < 16; x++) {
			if (cursor[y][x] == '*') {
				mouse[y * 16 + x] = table_8_565[COL8_000000];
			}
			if (cursor[y][x] == 'O') {
				mouse[y * 16 + x] = table_8_565[COL8_FFFFFF];
			}
			if (cursor[y][x] == '.') {
				mouse[y * 16 + x] = table_8_565[bc & 0xff];
			}
		}
	}
	return;
}

unsigned char rgb2pal(int r, int g, int b, int x, int y)
{
	static int table[4] = { 3, 1, 0, 2 };
	int i;
	x &= 1;					/*  */
	y &= 1;
	i = table[x + y * 2];	/* ԐF邽߂̒萔 */
	r = (r * 21) / 256;		/*  0`20 ɂȂ */
	g = (g * 21) / 256;
	b = (b * 21) / 256;
	r = (r + i) / 4;		/*  0`5 ɂȂ */
	g = (g + i) / 4;
	b = (b + i) / 4;
	return 16 + r + g * 6 + b * 36;
}

static int lx, ly;

void print_logo(short *buf, int xx, int yy, int ispush)
{
	static char *logo[9] = {
		"*********.......*****",
		".*.......*.....*.....",
		"..*.......*...*......",
		"...*.......*.*.......",
		"....*.......*........",
		"...*.......*.*.......",
		"..*.......*...*......",
		".*.......*.....*.....",
		"*********.......*****"
	};
	int x, y;

	for (y = 0; y < 9; y++) {
		for (x = 0; x < 21; x++) {
			if (logo[y][x] == '*') {
				buf[(y + ly + ispush) * xx + (x + lx + ispush)] = table_8_565[COL8_000000];
			}
		}
	}
	return;
}

// ^XNo[`悷
void put_taskbar(struct SHEET *sht)
{
	short *buf = sht->buf;
	int x = sht->bxsize;
	int y = sht->bysize;

	boxfill8(buf, x, 0, 0, 0, x, y);

	sht->flags |= 0x100;	// ŒEChE
	sheet_refresh(sht, 0, 0, x, y);
	return;
}

// fXNgbv`[pACR`悷
void put_icon(struct SHEET *sht)
{
	short *buf = sht->buf;
	extern int *tmp_fat;
	int x = sht->bxsize;
	int y = sht->bysize;

	boxfill8(buf, x, 0, 0, 0, x, y);

	if (loadimg(buf, "term.bmp", 0, 0, x, tmp_fat) != 0) {}
	putfonts8_asc(buf, x, 1, 32, COL8_FFFFFF, "term");
	putfonts8_asc(buf, x, 0, 32, 17, "term");

	if (loadimg(buf, "file.bmp", 0, 32*1+16*1, x, tmp_fat) != 0) {}
	putfonts8_asc(buf, x, 1, 32*2+16*1, COL8_FFFFFF, "file");
	putfonts8_asc(buf, x, 0, 32*2+16*1, 17, "file");

	if (loadimg(buf, "paint.bmp", 0, 32*2+16*2, x, tmp_fat) != 0) {}
	putfonts8_asc(buf, x, 1, 32*3+16*2, COL8_FFFFFF, "draw");
	putfonts8_asc(buf, x, 0, 32*3+16*2, 17, "draw");

	if (loadimg(buf, "edit.bmp", 0, 32*3+16*3, x, tmp_fat) != 0) {}
	putfonts8_asc(buf, x, 1, 32*4+16*3, COL8_FFFFFF, "edit");
	putfonts8_asc(buf, x, 0, 32*4+16*3, 17, "edit");

	if (loadimg(buf, "help.bmp", 0, 32*4+16*4, x, tmp_fat) != 0) {}
	putfonts8_asc(buf, x, 1, 32*5+16*4, COL8_FFFFFF, "help");
	putfonts8_asc(buf, x, 0, 32*5+16*4, 17, "help");

	sht->flags |= 0x100;	// ŒEChE
	sheet_refresh(sht, 0, 0, x, y);
	return;
}

// X^[g{^p̃{^`悷
void put_button(struct SHEET *sht, int ispush)
{
	short *vram = sht->buf;
	int x = sht->bxsize;
	int y = sht->bysize;

	if (ispush == 0) {
		boxfill8(vram, x, COL8_C6C6C6,   0,     0,   x,     y);
		boxfill8(vram, x, COL8_FFFFFF,   0,     0, x-1,     0);
		boxfill8(vram, x, COL8_FFFFFF,   0,     0,   0,   y-1);
		boxfill8(vram, x, COL8_848484,   1,   y-2, x-2,   y-2);
		boxfill8(vram, x, COL8_848484, x-2,     1, x-2,   y-2);
		boxfill8(vram, x, COL8_000000,   0,   y-1, x-1,   y-1);
		boxfill8(vram, x, COL8_000000, x-1,     0, x-1,   y-1);
	} else {
		boxfill8(vram, x, COL8_C6C6C6,   0,     0,   x,     y);
		boxfill8(vram, x, COL8_000000,   0,     0,   x,     0);
		boxfill8(vram, x, COL8_000000,   0,     0,   0,     y);
		boxfill8(vram, x, COL8_848484,   1,     1, x-1,     1);
		boxfill8(vram, x, COL8_848484,   1,     1,   1,   y-1);
		boxfill8(vram, x, COL8_FFFFFF,   1,   y-1, x-1,   y-1);
		boxfill8(vram, x, COL8_FFFFFF, x-1,     1, x-1,   y-1);
	}

	// MOGEX S
	lx = 18;
	ly = 5;
	print_logo(vram, x, y, ispush);
	
	sht->flags |= 0x100;
	sheet_refresh(sht, 0, 0, x, y);
	return;
}

void msgbox(char *str)
{
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	struct SHEET *sht = sheet_alloc(shtctl);
	unsigned short *buf = (unsigned short *) memman_alloc_4k(memman, 256 * 165);
	sheet_setbuf(sht, buf, 256, 165, -1);
	make_window8(buf, 256, 165, "MOGEX", 0);
	sht->task = task_now();
	sht->flags |= 0x05;

	boxfill8(sht->buf, sht->bxsize, COL8_FFFFFF, 8, 27, sht->bxsize - 8, sht->bysize - 8);
	putfonts8_asc(sht->buf, sht->bxsize, 8, 30, COL8_000000, str);

	sheet_slide(sht, 60, 60);
	sheet_updown(sht, shtctl->top);
	return;
}

void abortbox(int *fat)
{
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	struct SHEET *sht = sheet_alloc(shtctl);
	unsigned short *buf = (unsigned short *) memman_alloc_4k(memman, 215 * 153);
	sheet_setbuf(sht, buf, 215, 153, -1);
	make_window8(buf, 215, 153, "abort", 0);
	sht->task = task_now();
	sht->flags |= 0x05;

	boxfill8(sht->buf, sht->bxsize, COL8_FFFFFF, 8, 27, sht->bxsize - 8, sht->bysize - 8);
	
	/* ǂݍ */
	loadimg(sht->buf, "abort.jpg", 8, 30, sht->bxsize, fat);

	sheet_slide(sht, 60, 60);
	sheet_updown(sht, shtctl->top);
	return;
}

extern Menu menuList[23];

void draw_menu(struct SHEET *sht, int mode)
{
	if (mode == 0) { /* main */
		int i;
		char s[32];
		for (i = 0; strcmp(menuList[i].title, "<END>"); i++) {
			if (!strcmp(menuList[i].title, "<SEP>")) {
				strcpy(s, "------------------------");
			} else {
				strcpy(s, menuList[i].title);
			}
			putfonts8_asc(sht->buf, sht->bxsize, 2, (i+1) * 20 + 3, 17, s);
		}
	}
	return;
}

struct SHEET *init_menu(struct SHTCTL *shtctl, struct TASK *task)
{
	struct BOOTINFO *binfo = (struct BOOTINFO *) ADR_BOOTINFO;
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	struct SHEET *sht = sheet_alloc(shtctl);
	unsigned short *buf = (unsigned short *) memman_alloc_4k(memman, 200 * 150);

	sheet_setbuf(sht, buf, 200, 150, -1);
	make_menu(buf, 200, 150, "MOGEX-Menu");
	sht->flags |= 0x200;

	draw_menu(sht, 0);

	sheet_slide(sht, 0, binfo->scrny-150-30);
	sheet_updown(sht, shtctl->top);

	return sht;
}

void close_menu(struct SHEET *sht)
{
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;

	memman_free_4k(memman, (int) sht->buf, 200 * 300);
	sheet_free(sht);

	return;
}

void make_menu(unsigned short *buf, int xsize, int ysize, char *title)
{

	boxfill8(buf, xsize,         COL8_FFFFFF, 0,         0,	        xsize    , ysize    );
	boxfill8(buf, xsize,         COL8_000000, 1,         1,         xsize - 2, ysize - 2);
	boxfill8(buf, xsize,         COL8_C6C6C6, 2,         2,         xsize - 3, ysize - 3);
	boxfill8(buf, xsize,         COL8_000000, 2,         2,         xsize - 3, 20       );

	putfonts8_asc(buf, xsize,                 3,         3,       COL8_FFFFFF, title);

	return;
}

void os_ver(void)
{
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	struct SHEET *sht = sheet_alloc(shtctl);
	unsigned short *buf = (unsigned short *) memman_alloc_4k(memman, 215 * 153);

	sheet_setbuf(sht, buf, 215, 153, -1);
	make_window8(buf, 215, 153, "About MOGEX", 0);
	sht->task = task_now();
	sht->flags |= 0x05;

	boxfill8(sht->buf, sht->bxsize, COL8_FFFFFF, 8, 27, sht->bxsize - 8, sht->bysize - 8);
	
	lx = 18;
	ly = 38;
	print_logo(sht->buf, sht->bxsize, sht->bysize, 0);

	char s[20];
	sprintf(s, "%s[ver%s]", OS_NAMEU, OS_VER);
	putfonts8_asc(sht->buf, sht->bxsize, lx + 21 + 10, 34, COL8_000000, s);
	putfonts8_asc(sht->buf, sht->bxsize, lx, 64, COL8_848484, "MOGEX is Open Source OS.");
	putfonts8_asc(sht->buf, sht->bxsize, lx, 64+16, COL8_848484, "http://mogex.ifdef.jp/");

	sheet_slide(sht, 60, 60);
	sheet_updown(sht, shtctl->top);
	return;
}
