/* }EX֌W */

#include "bootpack.h"

struct FIFO32 *mousefifo;
struct MOUSE_INFO minfo;
int mousedata0;
int mplag;

#define KEYCMD_SENDTO_MOUSE		0xd4
#define MOUSECMD_ENABLE			0xf4

void inthandler2c(int *esp)
/* PS/2}EX̊荞 */
{
	int data;
	io_out8(PIC1_OCW2, 0x64);	/* IRQ-12tPIC1ɒʒm */
	io_out8(PIC0_OCW2, 0x62);	/* IRQ-02tPIC0ɒʒm */
	data = io_in8(PORT_KEYDAT);
	if (data == 0xaa) {
		mplag = 1;
		goto send;
	}
	if (mplag == 1) {
		if (data == 0x00) {
			mouse_senddata(0xfa);
			return;
		} else {
			mplag = 0;
		}
	}
send:
	fifo32_put(mousefifo, data + mousedata0);
	return;
}

void enable_mouse(struct FIFO32 *fifo, int data0, struct MOUSE_DEC *mdec)
{
	int phase = 0, i;
	mplag = 0;
	/* ݐFIFOobt@L */
	mousefifo = fifo;
	mousedata0 = data0;
	/* }EXL */
	wait_KBC_sendready();
	io_out8(PORT_KEYCMD, KEYCMD_SENDTO_MOUSE);
	wait_KBC_sendready();
	io_out8(PORT_KEYDAT, MOUSECMD_ENABLE);
	/* ܂ACK(0xfa)MĂ */
	mdec->phase = 0; /* }EX0xfa҂ĂiK */

	/* XN[L */
	while (1) {
		i = mouse_senddata(0xf3);	// [][gݒR}hM
		if (i == 0xfa) {
			if (phase == 0) {
				i = mouse_senddata(200);
			} else if (phase == 1) {
				i = mouse_senddata(100);
			} else if (phase == 2) {
				i = mouse_senddata(80);
				if (i == 0xfa) {
					phase++;
				}
				break;
			}
			if (i == 0xfa) {
				phase++;
			} else {
				break;		// s
			}
		} else {
			break;			// s
		}
	}
	if (phase == 3 && mouse_senddata(0xf2) != 0x00) {
		mdec->scrollmode = 1;       // XN[}EX
	} else {
		mdec->scrollmode = 0;       // XN[}EXȂ
	}
	return;
}

/* }EXfoCXɃf[^𑗂B */
int mouse_senddata(int data)
{
    wait_KBC_sendready();
    io_out8(PORT_KEYCMD, KEYCMD_SENDTO_MOUSE);
    wait_KBC_sendready();
    io_out8(PORT_KEYDAT, data);
    io_cli();
    data = io_in8(PORT_KEYDAT);
    io_sti();
    return data;
}

int mouse_decode(struct MOUSE_DEC *mdec, unsigned char dat)
{
	if (mdec->phase == 0) {
		/* }EX0xfa҂ĂiK */
		if (dat == 0xfa) {
			mdec->phase = 1;
		}
		return 0;
	}
	if (mdec->phase == 1) {
		/* }EX1oCgڂ҂ĂiK */
		if ((dat & 0xc8) == 0x08) {
			/* 1oCgڂ */
			mdec->buf[0] = dat;
			mdec->phase = 2;
		}
		return 0;
	}
	if (mdec->phase == 2) {
		/* }EX2oCgڂ҂ĂiK */
		mdec->buf[1] = dat;
		mdec->phase = 3;
		return 0;
	}
	if (mdec->phase == 3) {
		/* }EX3oCgڂ҂ĂiK */
		mdec->buf[2] = dat;
		if (mdec->scrollmode == 0) mdec->phase = 1;
		else mdec->phase = 4;
		mdec->btn = mdec->buf[0] & 0x07;
		mdec->x = mdec->buf[1];
		mdec->y = mdec->buf[2];
		if ((mdec->buf[0] & 0x10) != 0) {
			mdec->x |= 0xffffff00;
		}
		if ((mdec->buf[0] & 0x20) != 0) {
			mdec->y |= 0xffffff00;
		}
		mdec->y = - mdec->y; /* }EXły̕ʂƔ */
		minfo.button = mdec->btn;
		if (mdec->x == 0 && mdec->y == 0) {
			if (mdec->btn == 0) {
				minfo.state = 1; /* RELEASED */
			} else {
				minfo.state = 2; /* PRESSED */
			}
		} else {
			if (mdec->btn == 0) {
				minfo.state = 3; /* MOVED */
			} else {
				minfo.state = 4; /* DRAGGED */
			}
		}
		if (mdec->scrollmode == 0) return 1;
	}
	if (mdec->phase == 4) {
		/* XN[Ή}EX̂݃XN[ */
		mdec->phase  = 1;
		mdec->scroll = mdec->buf[3] & 0x0f;
		if (mdec->scroll & 0x08) {
			mdec->scroll |= 0xfffffff0;
		}
		return 1;
	}
	return 1;
}
